#include <GL/glut.h>
#include <vector>
#include <assert.h>
#include "cxcore.h"
#include "highgui.h"
#define WIDTHBYTES(bits) ((((bits) + 31) / 32) * 4)   


class GLModule
{
public:
	GLModule (int argc, char* argv[]);
	~GLModule ();

	void glm_update();

	//int		g_nWinW;
	//int		g_nWinH;
	//float	g_fAngleX;
	//float	g_fAngleY;
	//float	g_fAngleZ;
	//void resize(int width, int height);
	//void update();
	//void keyboard(unsigned char key, int x, int y);
	//void keyboardext(int key, int x, int y);
	void gl_init(int argc, char* argv[]);

	void create_avi(char* video_name,double fps);
	void write_frame();
	void close_avi();
	void wait(double msec);
	void add_wav(char* sound_name);

	float*	p_fAngleX;
	float*	p_fAngleY;
	float*	p_fAngleZ;


	CvVideoWriter* avi;

	char avi_name[50];


	//HAVI avi;
	//HBITMAP hbm;

	//char image[500*500*3];

	IplImage* img;

	GLubyte img_gl[500][500][3];

};




class PVector2D
{
public:
	PVector2D() {/*empty*/}
	PVector2D(float _x, float _y) : x(_x), y(_y) {/*empty*/}
	PVector2D(const PVector2D& k)
	{
		(*this) = k;
	}
	PVector2D& operator=(const PVector2D& k)
	{
		x = k.x; y = k.y;
		return (*this);
	}
	bool operator ==(const PVector2D& k) const
	{
		return (x == k.x && y == k.y);
	}
	bool operator !=(const PVector2D& k) const
	{
		return (x != k.x || y != k.y);
	}

public:
	float x;
	float y;
};
typedef std::vector<PVector2D> VVector2D;
class PVector3D
{
public:
	PVector3D() {/*empty*/}
	PVector3D(float _x, float _y, float _z) : x(_x), y(_y), z(_z) {/*empty*/}
	PVector3D(const PVector3D& k)
	{
		(*this) = k;
	}
	PVector3D& operator=(const PVector3D& k)
	{
		x = k.x; y = k.y; z = k.z;
		return (*this);
	}
	bool operator ==(const PVector3D& k) const
	{
		return (x == k.x && y == k.y && z == k.z);
	}
	bool operator !=(const PVector3D& k) const
	{
		return (x != k.x || y != k.y || z != k.z);
	}

public:
	float x;
	float y;
	float z;
};
typedef std::vector<PVector3D> VVector3D;
class PTriangle
{
public:
	PTriangle() {/*empty*/}

	PTriangle(const PTriangle& k)
	{
		(*this) = k;
	}

	PTriangle& operator=(const PTriangle& k)
	{
		ipos[0] = k.ipos[0]; ipos[1] = k.ipos[1]; ipos[2] = k.ipos[2];
		itex[0] = k.itex[0]; itex[1] = k.itex[1]; itex[2] = k.itex[2];
		inor[0] = k.inor[0]; inor[1] = k.inor[1]; inor[2] = k.inor[2];
		return (*this);
	}

public:
	int ipos[3];	// position index array
	int itex[3];	// texture index array
	int inor[3];	// normal index array
};
typedef std::vector<PTriangle> VTriangle;
class PMesh
{
public:
	VTriangle vTri;
	VVector3D vPos;
	VVector3D vNor;
	VVector2D vTex;
};

int		g_nWinW;
int		g_nWinH;
float	g_fAngleX;
float	g_fAngleY;
float	g_fAngleZ;
PMesh g_mesh;
const char* g_szFileObj = "test.obj";
const char* g_szFileBmp = "test.bmp";
GLuint g_textureID;
unsigned char* g_pTexture = NULL;



unsigned char* loadbmpfile(const char* szFile, BITMAPINFOHEADER *bih)
{
	//---------------------------------
	if (szFile == NULL)
	{
		return false;
	}
	//---------------------------------

	//---------------------------------
	BITMAPFILEHEADER bfh;
	//---------------------------------

	//---------------------------------
	FILE* fp = fopen(szFile, "rb");
	if (fp == NULL)
	{
		return NULL;
	}
	//---------------------------------
  
	//---------------------------------
	fread(&bfh, sizeof(BITMAPFILEHEADER), 1, fp);

	if (bfh.bfType != 0x4D42)
	{
		fclose(fp);
		return NULL;
	}

	fread(bih, sizeof(BITMAPINFOHEADER), 1, fp);

	fseek(fp, bfh.bfOffBits, SEEK_SET);

	unsigned char* buffer = new unsigned char[bih->biSizeImage];
	if (buffer == NULL)
	{
		fclose(fp);
		return NULL;
	}

	fread(buffer, 1, bih->biSizeImage, fp);
	//---------------------------------

	//---------------------------------
	for (int i = 0; i < bih->biSizeImage; i+=3)
	{
		char ch			= buffer[i];
		buffer[i]		= buffer[i + 2];
		buffer[i + 2]	= ch;
	}
	//---------------------------------

	//---------------------------------
	printf("\n");
	printf("Texture File: %s\n", szFile);
	printf("Width       : %d\n", bih->biWidth);
	printf("Height      : %d\n", bih->biHeight);
	//---------------------------------

	//---------------------------------
	fclose(fp);
	return buffer;
	//---------------------------------
}

void parsetriangleindex(const char* szBuffer, int& nPos, int& nTex, int& nNor)
{
	assert(szBuffer);

	char szTemp[128];
	unsigned int nIndex		= 1;
	unsigned int nStart		= 0;
	unsigned int nStrLen	= strlen(szBuffer) + 1;

	nPos = 0;
	nTex = 0;
	nNor = 0;

	for (unsigned int i = 0; i < nStrLen; i++)
	{
		char ch = szBuffer[i];

		if (ch == '/' || ch == '\0')
		{
			if (i != nStart)
			{
				strncpy(szTemp, &szBuffer[nStart], i - nStart);
				szTemp[i - nStart] = '\0';

				switch (nIndex)
				{
					case 1: { nPos = atoi(szTemp); break; }
					case 2: { nTex = atoi(szTemp); break; }
					case 3: { nNor = atoi(szTemp); break; }
				}
			}

			nStart = i + 1;
			nIndex++;
		}
	}
}
void parsepolygonline(const char* szLine)
{
	assert(szLine);

	char szLineCopy[1024];

	unsigned int nIndex	= 0;
	int nPos;
	int nTex;
	int nNor;
	PTriangle tri;


	strcpy(szLineCopy, szLine + 2);

	int n = 0;

	char* szToken = strtok(szLineCopy, " ");

	while (szToken && n < 3)
	{
		parsetriangleindex(szToken, nPos, nTex, nNor);

		//-----	negative values not implemented!
		assert(nPos >= 0 && nTex >= 0 && nNor >= 0);

		tri.ipos[n] = nPos -1;
		tri.inor[n] = nNor -1;
		tri.itex[n] = nTex -1;

		szToken = strtok(NULL, " ");

		n++;
	}

	g_mesh.vTri.push_back(PTriangle(tri));
}
void parsevertexline(const char* szLine)
{
	assert(szLine);

	float fX = 0.0f;
	float fY = 0.0f;
	float fZ = 0.0f;

	if (szLine[1] == ' ')	// position
	{
		const char* szBuf = szLine + 2;

		sscanf(szBuf, "%f %f %f", &fX, &fY, &fZ);

		g_mesh.vPos.push_back(PVector3D(fX, fY, fZ));
	}
	else
	if (szLine[1] == 't')	// texture coordinate
	{
		const char* szBuf = szLine + 3;

		sscanf(szBuf, "%f %f %f", &fX, &fY);

		g_mesh.vTex.push_back(PVector2D(fX, fY));
	}
	else
	if (szLine[1] == 'n')	// normal
	{
		const char* szBuf = szLine + 3;

		sscanf(szBuf, "%f %f %f", &fX, &fY, &fZ);

		g_mesh.vNor.push_back(PVector3D(fX, fY, fZ));
	}
}
bool loadmesh(const char* szFile)
{
	//---------------------------------
	if (szFile == NULL)
	{
		return false;
	}
	//---------------------------------

	//---------------------------------
	FILE* fp = fopen(szFile, "r");
	if (!fp)
	{
		return false;
	}
	//---------------------------------

	//---------------------------------
	char szLine[1024];
	//---------------------------------

	//---------------------------------
	while (true)
	{
		if (fgets(szLine, 1024, fp) == NULL)
		{
			break;
		}

		//-----	remove end of line character
		szLine[strlen(szLine) - 1] = '\0';

		//-----	vertex line
		if (szLine[0] == 'v')
		{
			parsevertexline(szLine);
		}

		//-----	polygon line
		if (szLine[0] == 'f')
		{
			parsepolygonline(szLine);
		}
	}
	//---------------------------------

	//---------------------------------
	printf("\n");
	printf("Mesh File   : %s\n", g_szFileObj);
	printf("Triangles   : %d\n", g_mesh.vTri.size());
	printf("Vertices    : %d\n", g_mesh.vPos.size());
	printf("Normals     : %d\n", g_mesh.vNor.size());
	printf("UVs         : %d\n", g_mesh.vTex.size());
	//---------------------------------

	//---------------------------------
	fclose(fp);
	return true;
	//---------------------------------
}
void resize(int width, int height)
{
	g_nWinW = width;
	g_nWinH = height;

	if (height == 0)
	{
		height = 1;
	}

	const float ratio = 1.0f * width / height;

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glViewport(0, 0, width, height);
	gluPerspective(45.0f, ratio, 1.0f, 1000.0f);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt
			(
				0.0,
				0.0,
				5.0, 
				0.0,
				0.0,
				0.0,
				0.0f,
				1.0f,
				0.0f
			);
}

void render()
{


	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glPushMatrix();
		glTranslatef(0.0f, -5.0f, -65.0f);
		glRotatef(g_fAngleX, 1.0f ,0.0f ,0.0f);
		glRotatef(g_fAngleY, 0.0f ,1.0f ,0.0f);
		glRotatef(g_fAngleZ, 0.0f ,0.0f ,1.0f);

		glBindTexture(GL_TEXTURE_2D, g_textureID);

		for (unsigned int i = 0 ; i < g_mesh.vTri.size(); i++)
		{
			glBegin(GL_TRIANGLES);

				const int* pipos = g_mesh.vTri[i].ipos;
				const int* pinor = g_mesh.vTri[i].inor;
				const int* pitex = g_mesh.vTri[i].itex;

				for (unsigned int v = 0; v < 3; v++)
				{
					const PVector3D& pos = g_mesh.vPos[pipos[v]];
//					const PVector3D& nor = g_mesh.vNor[pinor[v]];
					const PVector2D& tex = g_mesh.vTex[pitex[v]];
					
					glTexCoord2f(tex.x, tex.y);
//					glNormal3f(nor.x, nor.y, nor.z);
					glVertex3f(pos.x, pos.y, pos.z);
				}

			glEnd();
		}

	glPopMatrix();
	glutSwapBuffers();

}
void update()
{
	//g_fAngleY += 0.05f;


	//glutSetWindow(right_id);
	//glutPostRedisplay();
		
	//glutSetWindow(left_id);
	//glutPostRedisplay();
	render();
}
void keyboard(unsigned char key, int x, int y)
{
	//if (key == 27)
	//{
	//	exit(0);
	//}

	if (key == 'w' || key == 'W')
	{
		GLint mode[2];
		glGetIntegerv(GL_POLYGON_MODE, mode);

		if (mode[0] == GL_LINE)
		{
			glEnable(GL_CULL_FACE);
			glPolygonMode(GL_FRONT, GL_FILL);
		}
		else
		{
			glDisable(GL_CULL_FACE);
			glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
		}
	}
}
void initopengl()
{



	const GLfloat litpos[] = {18.0f, 18.0f, 18.0f, 0.0f};
	const GLfloat litamb[] = {0.7f, 0.7f, 0.7f, 1.0f};
	const GLfloat litdif[] = {0.7f, 0.7f, 0.7f, 1.0f};
	const GLfloat litspe[] = {1.0f, 1.0f, 1.0f, 1.0f};

	const GLfloat matamb[] = {0.6f, 0.6f, 0.6f, 1.0f};
	const GLfloat matdif[] = {0.6f, 0.6f, 0.6f, 1.0f};
	const GLfloat matspe[] = {1.0f, 1.0f, 1.0f, 1.0f};

	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);

	glEnable(GL_LIGHT0);
	glLightfv(GL_LIGHT0, GL_POSITION, litpos);
	glLightfv(GL_LIGHT0, GL_AMBIENT, litamb);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, litdif);
	glLightfv(GL_LIGHT0, GL_SPECULAR, litspe);
	glEnable(GL_LIGHTING);

	glEnable(GL_DEPTH_TEST);
	glShadeModel(GL_SMOOTH);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	glEnable(GL_NORMALIZE);
	glDepthFunc(GL_LEQUAL);
	glClearDepth(1.0f);
	glEnable(GL_TEXTURE_2D);

	glMaterialfv(GL_FRONT, GL_AMBIENT, matamb);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, matdif);
//	glMaterialfv(GL_FRONT, GL_DIFFUSE, matspe);
}
bool settexture(const char* szFile)
{
	//---------------------------------
	BITMAPINFOHEADER bih;
	g_pTexture = loadbmpfile(szFile, &bih);
	if (g_pTexture == NULL)
	{
		return false;
	}
	//---------------------------------

	//---------------------------------
	glGenTextures(1, &g_textureID);
	glBindTexture(GL_TEXTURE_2D, g_textureID);

	glTexImage2D
			(
				GL_TEXTURE_2D,
				0,
				GL_RGB,
				bih.biWidth,
				bih.biHeight,
				0,
				GL_RGB,
				GL_UNSIGNED_BYTE,
				g_pTexture
			);

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);

	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	//---------------------------------

	//---------------------------------
	return true; 
	//---------------------------------
}
void destroy()
{
	delete [] g_pTexture;
	g_pTexture = NULL;
}
void keyboardext(int key, int x, int y)
{
	if ( key == GLUT_KEY_F1)
	{
		g_fAngleX = 0.0f;
		g_fAngleY = 0.0f;
		g_fAngleZ = 0.0f;
	}

}
HBITMAP CreateRGBBitmap(char* pImage, int nWidth, int nHeight)
{
	LPBITMAPINFO lpbi = new BITMAPINFO;
	lpbi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	lpbi->bmiHeader.biWidth = nWidth;
	lpbi->bmiHeader.biHeight = nHeight;
	lpbi->bmiHeader.biPlanes = 1;
	lpbi->bmiHeader.biBitCount = 24;
	lpbi->bmiHeader.biCompression = BI_RGB;
	lpbi->bmiHeader.biSizeImage = WIDTHBYTES((DWORD)nWidth * 8) * nHeight;
	lpbi->bmiHeader.biXPelsPerMeter = 0;
	lpbi->bmiHeader.biYPelsPerMeter = 0;
	lpbi->bmiHeader.biClrUsed = 0;
	lpbi->bmiHeader.biClrImportant = 0;

	void* pBits;

	HBITMAP hBitmap = CreateDIBSection( 
		NULL,               
		lpbi,                
		DIB_RGB_COLORS, 
		(void **)&pBits,
		NULL, 
		0 );

	delete lpbi;

	if ( hBitmap )
		SetBitmapBits(hBitmap, nWidth*nHeight*3, pImage);

	return hBitmap;
}
void GLModule::glm_update()
{
	//glutCheckLoop();

}
void GLModule::create_avi(char* video_name,double fps)
{

	strcpy(avi_name,video_name);

	img = cvCreateImage( cvSize(500,500) , IPL_DEPTH_8U  , 3 );
	//avi = cvCreateVideoWriter( avi_name , CV_FOURCC('I','V','5','0') , 30.0 , cvSize(500,500), 1 );
	avi = cvCreateVideoWriter( avi_name , CV_FOURCC('I','V','5','0') , 30.0 , cvSize(500,500), 1 );

	//hbm=CreateRGBBitmap(image,500,500);
	//img_gl = new GLubyte[500*500*3];
	//avi = CreateAvi(video_name,(int)(1000.0/fps),NULL);
	//AVICOMPRESSOPTIONS opts; ZeroMemory(&opts,sizeof(opts));
	//opts.fccHandler=mmioFOURCC('d','i','v','x');		
	//SetAviVideoCompression(avi,hbm,&opts,true,NULL);
}
void GLModule::write_frame()
{
	glReadPixels(0,0,500,500,GL_RGB,GL_UNSIGNED_BYTE,img_gl);


	for (int i = 0; i<500 ; i++)
	{
		for (int j = 0 ; j<500 ; j++)
		{
			img->imageData[img->widthStep*(500-i-1)+3*j]=(char)img_gl[i][j][2];
			img->imageData[img->widthStep*(500-i-1)+3*j+1]=(char)img_gl[i][j][1];
			img->imageData[img->widthStep*(500-i-1)+3*j+2]=(char)img_gl[i][j][0];
		
		
		}
	}

	cvWriteFrame( avi, img );




	//for(int i=0;i<500;i++)
	//{
	//	for(int j=0;j<500;j++)
	//	{
	//		image[(500-i-1)*500*3+j*3]=(char)img_gl[i*500*3+j*3+2];
	//		image[(500-i-1)*500*3+j*3+1]=(char)img_gl[i*500*3+j*3+1];
	//		image[(500-i-1)*500*3+j*3+2]=(char)img_gl[i*500*3+j*3];
	//	}
	//}
	//SetBitmapBits(hbm, 500*500*3, image);
	//AddAviFrame(avi,hbm);
}
void GLModule::add_wav(char* sound_name)
{


	HAVI my_avi  = OpenAvi(avi_name,NULL);
	AddAviWav(my_avi,sound_name,SND_FILENAME);
	CloseAvi(my_avi);	


	//AddAviWav(avi,sound_name, SND_FILENAME);
}
void GLModule::close_avi()
{
	//DeleteObject(hbm);
	//CloseAvi(avi);
	cvReleaseVideoWriter( &avi );
	cvReleaseImage(&img);

}
GLModule::GLModule (int argc, char* argv[])
{
	g_nWinW		= 500;
	g_nWinH		= 500;
	g_fAngleX	= 0.0f;
	g_fAngleY	= 0.0f;
	g_fAngleZ	= 0.0f;

	p_fAngleX = &g_fAngleX;
	p_fAngleY = &g_fAngleY;
	p_fAngleZ = &g_fAngleZ;

	


	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
	glutInitWindowPosition(0, 0); 
	glutInitWindowSize(g_nWinW, g_nWinH);
	glutCreateWindow("OpenGL Test Application");
	glutDisplayFunc(render); 
	glutIdleFunc(update); 
	glutReshapeFunc(resize);
	glutKeyboardFunc(keyboard);
	glutSpecialFunc(keyboardext);


	initopengl();
	//---------------------------------
	if (loadmesh(g_szFileObj) == false)
	{
		printf("can't load mesh file!\n");
		exit(1);
	}
	//---------------------------------
	if (settexture(g_szFileBmp) == false)
	{
		printf("can't load texture file!\n");
		exit(1);
	}







	//glutCheckLoop();
}

GLModule::~GLModule ()
{

}
double GetRunTime(void)
{
	double msec = 0;
	int64 timeval = cvGetTickCount();
	msec = (double)(timeval/cvGetTickFrequency())/1000000.0;
	return(msec);
}
void GLModule::wait(double msec)
{

	double tstart = -1;
	double tstop;

	if (tstart < 0)
		tstart = GetRunTime();

	tstop = tstart;
	
	while (tstop - tstart < msec/1000.0) 
	{
		tstop = GetRunTime();
	}


}

