#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "cv.h"
#include "cxcore.h"
#include "HMMUtil.h"
#include "avi_utils.h"
#include "GLUtil.h"
#include "LinkedList.h"


#include "mmsystem.h"

struct event{
	int start_frame;
	int end_frame;
	float start;
	float end;
	char label[50];
} ;
int skip_line(FILE* fid)
{
	char temp;
	fscanf(fid,"%c",&temp);
	while(temp!='\n')
	{
		fscanf(fid,"%c",&temp);
	}
	return 0;
}
void load_event(event* p_event,float start,float end, char* label)
{
	p_event->start = start;
	
	p_event->end = end;

	p_event->start_frame = (int)(p_event->start * 30.0);
	p_event->end_frame = (int)(p_event->end * 30.0)-1;


	strcpy(p_event->label,label);
}
int get_num_events(char* label_name)
{

	//FILE* fid_in = fopen(argv[1],"r");
	FILE* fid_in = fopen(label_name,"r");
	FILE* fid_out = fopen("output.txt","w");
	//FILE* fid_out = fopen(argv[2],"w");
	skip_line(fid_in);
	skip_line(fid_in);
	char c=NULL;
	char label[50];
	float start;
	float end;
	float log_p;
	float thresh=-10000.0;//sscanf(argv[3],"%f",&thresh);
	
	//float start2=0.0f, end2=0.0f;
	
	int i=0;


	while(c!='.')
	{

		fscanf(fid_in,"%f",&start);
		fscanf(fid_in,"%f",&end);
		fscanf(fid_in,"%s",label);
		fscanf(fid_in,"%f",&log_p);
		skip_line(fid_in);

		if(log_p>thresh && ( !strcmp(label,"a") || !strcmp(label,"d") ) )
		{
			i++;
			//end2 = start;
			//fprintf(fid_out,"%f %f %s %f\n",start2/1e7,end2/1e7,"sil",log_p);
			//start2 = end;



			i++;
			//fprintf(fid_out,"%f %f %s %f\n",start/1e7,end/1e7,label,log_p);
		}
		c=fgetc(fid_in);
		ungetc(c,fid_in);
	}

	i++;
	//end2 = end;
	//fprintf(fid_out,"%f %f %s %f\n",start2/1e7,end2/1e7,"sil",log_p);

	fclose(fid_in);
	fclose(fid_out);

	return i;


}


void load_event_timestamps(char* label_name,event* events)
{
	//FILE* fid_in = fopen(argv[1],"r");
	FILE* fid_in = fopen(label_name,"r");
	//FILE* fid_out = fopen("output.txt","w");
	//FILE* fid_out = fopen(argv[2],"w");
	skip_line(fid_in);
	skip_line(fid_in);
	char c=NULL;
	char label[50];
	float start;
	float end;
	float log_p;
	float thresh=-10000.0;//sscanf(argv[3],"%f",&thresh);
	
	float start2=0.0f, end2=0.0f;
	
	int i=0;


	while(c!='.')
	{

		fscanf(fid_in,"%f",&start);
		fscanf(fid_in,"%f",&end);
		fscanf(fid_in,"%s",label);
		fscanf(fid_in,"%f",&log_p);
		skip_line(fid_in);

		if(log_p>thresh && ( !strcmp(label,"a") || !strcmp(label,"d") ) )
		{
			end2 = start;

			load_event(&events[i],start2/1e7f,end2/1e7f,"sil");
			//events[i].start = start2/1e7f;
			//events[i].end = end2/1e7f;
			//strcpy(events[i].label,"sil");

			i++;

			//fprintf(fid_out,"%f %f %s %f\n",start2/1e7,end2/1e7,"sil",log_p);

			start2 = end;

			load_event(&events[i],start/1e7f,end/1e7f,label);
			//events[i].start = start/1e7f;
			//events[i].end = end/1e7f;
			//strcpy(events[i].label,label);
			
			i++;
			//fprintf(fid_out,"%f %f %s %f\n",start/1e7,end/1e7,label,log_p);
			//fprintf(fid_out,"%f %f %s\n",start/1e7,end/1e7,label);
		}
		c=fgetc(fid_in);
		ungetc(c,fid_in);
	}

	end2 = end;
	load_event(&events[i],start2/1e7f,end2/1e7f,"sil");
	//events[i].start = start2/1e7f;
	//events[i].end = end2/1e7f;
	//strcpy(events[i].label,"sil");	
	//fprintf(fid_out,"%f %f %s %f\n",start2/1e7,end2/1e7,"sil",log_p);

	fclose(fid_in);
	//fclose(fid_out);


}

#define myDebug 0

double generate_rand_observation(sHMM* hmm,int state,double** observation,CvRNG* rng)
{
	//cvRandInit( &rng,0, 1, 0xffffffff,CV_RAND_UNI)
	CvMat* temp   = cvCreateMat(hmm->vec_dim[0],1,CV_64FC1);
	CvMat* covar  = cvCreateMat(hmm->vec_dim[0],hmm->vec_dim[0],CV_64FC1);
	CvMat* evects = cvCreateMat(hmm->vec_dim[0],hmm->vec_dim[0],CV_64FC1);
	CvMat* evals2 = cvCreateMat(hmm->vec_dim[0],hmm->vec_dim[0],CV_64FC1);
	CvMat* evals  = cvCreateMat(hmm->vec_dim[0],1,CV_64FC1);
	CvMat* dst    = cvCreateMat(hmm->vec_dim[0],1,CV_64FC1);


	cvZero( temp );
	cvZero( covar );
	cvZero( evects );
	cvZero( evals );
	cvZero( evals2 );
	cvZero( dst );

	for(int i=0;i<hmm->num_streams;i++)
		for(int j=0;j<hmm->vec_dim[i];j++)
			observation[i][j]=0.0;

	for(int k=0;k<hmm->num_streams;k++)
	{
		for(int i=0;i<hmm->vec_dim[0];i++)
		{
			for(int j=i;j<hmm->vec_dim[0];j++)
			{
				cvSetReal2D( covar, i, j, hmm->variance[k][state][0][i*hmm->vec_dim[0]+j] );
				cvSetReal2D( covar, j, i, hmm->variance[k][state][0][i*hmm->vec_dim[0]+j] );
			}
		}
	}

#if myDebug
	printf("\ncovariance matrix:\n");
	for(int i=0;i<hmm->vec_dim[0];i++)
	{
		for(int j=0;j<hmm->vec_dim[0];j++)
		{
			printf("%.10f  ",cvGetReal2D( covar, i, j ));
		}
		printf("\n");
	}
#endif

	if ( strcmp(hmm->cKind,"diag") != 0 )
		double cond = cvInvert( covar, covar, CV_SVD );

#if myDebug
	printf("\n inverse covariance matrix:\n");
	for(int i=0;i<hmm->vec_dim[0];i++)
	{
		for(int j=0;j<hmm->vec_dim[0];j++)
		{
			printf("%.10f  ",cvGetReal2D( covar, i, j ));
		}
		printf("\n");
	}
#endif

	cvEigenVV( covar, evects, evals, DBL_EPSILON );

	cvTranspose( evects, evects );

#if myDebug
	printf("\n eigenvector matrix:\n");
	for(int i=0;i<hmm->vec_dim[0];i++)
	{
		for(int j=0;j<hmm->vec_dim[0];j++)
		{
			printf("%.10f  ",cvGetReal2D( evects, i, j ));
		}
		printf("\n");
	}
#endif

	for(int i=0;i<hmm->vec_dim[0];i++)
	{
		cvSetReal2D( evals2, i, i, cvSqrt(cvGetReal1D( evals, i )) );
	}

#if myDebug
	printf("\n square root of eigenvalue matrix:\n");
	for(int i=0;i<hmm->vec_dim[0];i++)
	{
		for(int j=0;j<hmm->vec_dim[0];j++)
		{
			printf("%.10f  ",cvGetReal2D(evals2,i,j) );
		}
		printf("\n");
	}
#endif

	


	//cvRandArr( rng,temp,CV_RAND_NORMAL,cvRealScalar(hmm->mean[i][state][k][j]),cvRealScalar(sqrt(hmm->variance[i][state][k][j])));
	cvRandArr( rng,temp,CV_RAND_NORMAL,cvRealScalar(0),cvRealScalar(1) );

#if myDebug
	printf("\n random x vector:\n");
	for(int i=0;i<hmm->vec_dim[0];i++)
	{
			printf("%.10f  ", cvGetReal1D(temp,i) );
	}
#endif


	cvGEMM( evals2, temp, 1, 0, 0, dst, 0 );

#if myDebug
	printf("\n square rooted eigenvalues times x:\n");
	for(int i=0;i<hmm->vec_dim[0];i++)
	{
			printf("%.10f  ", cvGetReal1D(dst,i) );
	}
#endif

	cvGEMM( evects, dst, 1, 0, 0, dst, 0 );

#if myDebug
	printf("\n eigenvector matrix times square rooted eigenvalues times x:\n");
	for(int i=0;i<hmm->vec_dim[0];i++)
	{
			printf("%.10f  ", cvGetReal1D(dst,i) );
	}
#endif


	for(int i=0;i<hmm->num_streams;i++)
		for(int j=0;j<hmm->vec_dim[i];j++)
			//observation[i][j]=observation[i][j] + hmm->weights[i][state][k]*(double)temp->data.fl[0];
			observation[i][j] = hmm->mean[i][state][0][j] + hmm->weights[i][state][0]*cvGetReal1D(dst,j);



	cvReleaseMat( &temp );
	cvReleaseMat( &covar );
	cvReleaseMat( &evects );
	cvReleaseMat( &evals );
	cvReleaseMat( &evals2 );
	cvReleaseMat( &dst );

	return 0;


}
int generate_sequence(sHMM* hmm,CvMat* euler_angles,CvRNG* rng,int start,int end)
{


	int vec_dim = hmm->vec_dim[0];

		
	CvMat* state_trans = cvCreateMat(hmm->num_states-2,1,CV_32FC1 );

	for(int i=0;i<state_trans->height;i++)
	{
		cvSetReal1D(state_trans,i,(double)(i+1));
	}


	CvMat* state_trans_final = cvCreateMat(end-start+1,1,CV_32FC1 );

	cvResize(state_trans,state_trans_final,CV_INTER_LINEAR );


	int state_num = 0;

	for(int i=start;i<=end;i++)
	{
			state_num = cvRound(cvGetReal1D(state_trans_final,i-start));
			double** observation = new double*[hmm->num_streams];
			for(int k = 0; k<hmm->num_streams;k++)
				observation[k]=new double[hmm->vec_dim[k]];
			
			generate_rand_observation(hmm,state_num,observation,rng);

			for(int j=0;j<vec_dim;j++)
			{
				cvSetReal2D(euler_angles,i,j,observation[0][j]);
			}
			for(int k = 0; k<hmm->num_streams;k++)
				delete observation[k];
			delete observation;


	}

	cvReleaseMat(&state_trans);
	cvReleaseMat(&state_trans_final);

	return 0;

}




double find_med(CvMat* src )
{


	CvMat* src_cpy = cvCloneMat( src );




	double med = 0.0;
	
	for(int i=0;i<src_cpy->rows;i++)
	{
		for(int j=0;j<src_cpy->rows-1-i;j++)
		{
			if(cvGetReal1D(src_cpy,j)>cvGetReal1D(src_cpy,j+1))
			{
				double temp = cvGetReal1D(src_cpy,j);
				cvSetReal1D(src_cpy,j,cvGetReal1D(src_cpy,j+1));
				cvSetReal1D(src_cpy,j+1,temp);
			}
		}
	}
	
	//for(int j=0;j<src->rows;j++)
	//{
	//	printf("%.0f %.0f\n",cvGetReal1D(src,j),cvGetReal1D(src_cpy,j));
	//}
	//printf("\n");


	med = cvGetReal1D(src_cpy,(src_cpy->rows-1)/2);

	cvReleaseMat(&src_cpy);

	return med;
}
int med_filter(CvMat* src, CvMat* dst, int size)
{

	CvMat* col_mat = cvCreateMat(src->rows+(size-1),1,src->type);
	CvMat sub_rect ;

	for(int i=0;i<src->cols;i++)
	{
	
		for(int j=0;j<(size-1)/2;j++)
		{
			cvSetReal1D(col_mat,j,0.0);
		}
		for(int j=col_mat->rows-(size-1)/2;j<col_mat->rows;j++)
		{
			cvSetReal1D(col_mat,j,0.0);
		}

		for(int j=0;j<src->rows;j++)
		{
			cvSetReal1D(col_mat,j+2,cvGetReal2D(src,j,i));
		}
	



		for(int j=0;j<src->rows;j++)
		{
			cvGetSubRect(col_mat, &sub_rect, cvRect(0,j,1,size) );
			cvSetReal2D(dst,j,i,find_med(&sub_rect));
		
		
		}
	
		//for(int j=0;j<col_mat->rows;j++)
		//{
		//	printf("%f\n",cvGetReal1D(col_mat,j));
		//}
		//for(int j=0;j<dst->rows;j++)
		//{
		//	printf("%f\n",cvGetReal2D(dst,j,i));
		//}	
	
	
	}


	//cvReleaseMat(&sub_rect);
	cvReleaseMat(&col_mat);



	return 0;
}
int load_filter(CvMat* filter)
{
	int dim = filter->rows;
	int dim2 = cvFloor( (double)dim / 2.0 ); 
	for(int i=-dim2;i<=dim2;i++)
		//cvSetReal1D(filter,i+dim2,1.0);
		cvSetReal1D(filter,i+dim2,exp(-0.5/10*i*i));
	CvScalar temp_sum = cvSum( filter );
	cvConvertScale( filter, filter, 1/temp_sum.val[0], 0 );
	return 0;
}


int main(int argc, char *argv[])
{
	
	int item1,item2,item3;
	char type;

	// euler
	//int fapsUsed[4] = {48,49,50};
	// gozler
	// int fapsUsed[4] = {19,20,21,22};
	// sol kas
	// int fapsUsed[4] = {31,33,35,37};
	// sag kas
	// int fapsUsed[4] = {32,34,36,38};
	// iki kas
	// int fapsUsed[8] = {31,32,33,34,35,36,37,38};

	CvRNG rng = cvRNG( 3 );
	int vec_size   = 18;
	int num_models = 1;

	// input HMM files
	char* in_hmm_name_su = "D:/My Documents/research/enterface/synthesis/HMMs/salsa_upper_22";
	char* in_hmm_name_sl = "D:/My Documents/research/enterface/synthesis/HMMs/salsa_lower_24";
	char* in_hmm_name_bu = "D:/My Documents/research/enterface/synthesis/HMMs/belly_upper_10";
	char* in_hmm_name_bl = "D:/My Documents/research/enterface/synthesis/HMMs/belly_lower_22";
	// input HMM list file
	char* in_hmmlist_name = "D:/My Documents/research/enterface/synthesis/HmmList.txt";
	
	// input label file
	char *file_name = "D:/My Documents/research/enterface/synthesis/labels/demo_zorba.lab";
	// demo file
	char *demo_name = "D:/My Documents/research/enterface/synthesis/demo_zorba.txt";
	// output synthesis file
	char *segment_name_t = "D:/My Documents/research/enterface/synthesis/synthesized/synthesized%d_demo_zorba_upper.txt";
	// upper or lower body
	char u_l = 'u';


	// HMM for salsa upper
	HMMModule hmmm_su(argc,argv);
	strcpy(hmmm_su.in_hmm_name,in_hmm_name_su);
	hmmm_su.Initialise2(in_hmmlist_name);
	sHMM* hmm_su = new sHMM[num_models];
	for (int i = 0 ; i < num_models ; i++)
	{
		char temp[2]; sprintf(temp,"%c",'a'+i);// = "a"; temp[0]=temp[0]+1;
		hmmm_su.set_hmm(temp); hmmm_su.read_hmm(&hmm_su[i]);
	}

	// HMM for salsa lower
	HMMModule hmmm_sl(argc,argv);
	strcpy(hmmm_sl.in_hmm_name,in_hmm_name_sl);
	hmmm_sl.Initialise2(in_hmmlist_name);
	sHMM* hmm_sl = new sHMM[num_models];
	for (int i = 0 ; i < num_models ; i++)
	{
		char temp[2]; sprintf(temp,"%c",'a'+i);// = "a"; temp[0]=temp[0]+1;
		hmmm_sl.set_hmm(temp); hmmm_sl.read_hmm(&hmm_sl[i]);
	}
	
	// HMM for belly upper
	HMMModule hmmm_bu(argc,argv);
	strcpy(hmmm_bu.in_hmm_name,in_hmm_name_bu);
	hmmm_bu.Initialise2(in_hmmlist_name);
	sHMM* hmm_bu = new sHMM[num_models];
	for (int i = 0 ; i < num_models ; i++)
	{
		char temp[2]; sprintf(temp,"%c",'a'+i);// = "a"; temp[0]=temp[0]+1;
		hmmm_bu.set_hmm(temp); hmmm_bu.read_hmm(&hmm_bu[i]);
	}

	// HMM for belly lower
	HMMModule hmmm_bl(argc,argv);
	strcpy(hmmm_bl.in_hmm_name,in_hmm_name_bl);
	hmmm_bl.Initialise2(in_hmmlist_name);
	sHMM* hmm_bl = new sHMM[num_models];
	for (int i = 0 ; i < num_models ; i++)
	{
		char temp[2]; sprintf(temp,"%c",'a'+i);// = "a"; temp[0]=temp[0]+1;
		hmmm_bl.set_hmm(temp); hmmm_bl.read_hmm(&hmm_bl[i]);
	}

	
	int num_frames = 6000;

	CvMat* euler_angles = cvCreateMat(num_frames,vec_size,CV_32FC1 );cvZero(euler_angles);
	CvMat* euler_angles_final = cvCreateMat(num_frames,vec_size,CV_32FC1 );


	cvRandArr( &rng,euler_angles,CV_RAND_NORMAL,cvRealScalar(0.0),cvRealScalar(1.0));
	
	

	//generate_sequence(&hmm[1],euler_angles,&rng,0,num_frames-1);

	LinkedList<int> ind_labels;
	LinkedList<int> hmm_types;
	FILE *fid = fopen(file_name,"r");
	while( fscanf(fid,"%c %d %d %d\n",&type,&item1,&item2,&item3) > 0 )
	{
		ind_labels.InsertAfter(item1,item2,item3,(int)type,0);
		for(int i=item1;i<item2;i++)
			hmm_types.InsertAfter((int)type,0,0,0,0);

	}
	fclose(fid);


	CvMat* temp_motion;

	for( ind_labels.Reset(); !ind_labels.EndOfList() ;ind_labels.Next())
	{
		if(ind_labels.Data2()>num_frames)
			break;

		temp_motion = cvCreateMat(ind_labels.Data2()+3-ind_labels.Data1()+3+1,vec_size,CV_32FC1 );

		sHMM *hmm;
		if ( (char)ind_labels.Data4() == 's' && u_l == 'u' )
			hmm = &hmm_su[ind_labels.Data3()-1];
		else if ( (char)ind_labels.Data4() == 's' && u_l == 'l' )
			hmm = &hmm_sl[ind_labels.Data3()-1];
		else if ( (char)ind_labels.Data4() == 'b' && u_l == 'u' )
			hmm = &hmm_bu[ind_labels.Data3()-1];
		else if ( (char)ind_labels.Data4() == 'b' && u_l == 'l' )
			hmm = &hmm_bl[ind_labels.Data3()-1];
		else
			;
		//generate_sequence(&hmm[ind_labels.Data3()-1],temp_motion,&rng,0,ind_labels.Data2()-ind_labels.Data1()+6);
		generate_sequence(hmm,temp_motion,&rng,0,ind_labels.Data2()-ind_labels.Data1()+6);


		for (int i = ind_labels.Data1() - 3 ; i < ind_labels.Data1() +3 ; i++ )
		{
			if (i>0)
			{
				for (int j=0; j<vec_size; j++)
				{
					cvSetReal2D(euler_angles,i,j,cvGetReal2D(temp_motion,i-ind_labels.Data1()+3,j)/2.0 + cvGetReal2D(euler_angles,i,j));
				}
			}
		
		
		}
		for (int i = ind_labels.Data1() + 3 ; i < ind_labels.Data2() -3 ; i++ )
		{
			for (int j=0; j<vec_size; j++)
			{
				cvSetReal2D(euler_angles,i,j,cvGetReal2D(temp_motion,i-ind_labels.Data1()+3,j));
			}
		}

		for (int i = ind_labels.Data2() -3  ; i < ind_labels.Data2()+3+1 ; i++ )
		{
			if (i<num_frames && i>0)
			{
				for (int j=0; j<vec_size; j++)
				{
				cvSetReal2D(euler_angles,i,j,cvGetReal2D(temp_motion,i-ind_labels.Data1()+3,j)/2.0 + cvGetReal2D(euler_angles,i,j));
				}
			}		
		
		}


		cvReleaseMat(&temp_motion);
	}




	int filter_dim = 15;
	CvMat* filter = cvCreateMat(filter_dim,1,CV_32FC1);
	load_filter(filter);

	
	med_filter(euler_angles,euler_angles_final,11);
	cvFilter2D( euler_angles_final, euler_angles, filter, cvPoint(-1,-1));


	char segment_name[255];
	int start_ind, end_ind;

	int segment_count = 1;

	fid = fopen(demo_name,"r");


	//int faps[68]={0};

	//for (int i=0; i<vec_size; i++)
	//{
	//	faps[fapsUsed[i]-1] = 1;
	//}


	int identifier;
	
	while(fscanf(fid,"%d %d",&start_ind, &end_ind )>0 )
	{
		sprintf(segment_name,segment_name_t,segment_count);
		segment_count++;

		FILE* fid2 = fopen(segment_name,"w");
		
		int cccc = 0;
		hmm_types.Reset(start_ind);
		for (int i = start_ind; i < end_ind ; i++)
		{
			if ( (char)hmm_types.Data1() == 's' ) identifier = 1; else identifier = 2;
			//fprintf(fid2,"%d 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0",cccc++);
			//fprintf(fid2,"%d",cccc++);
			fprintf(fid2,"%d",identifier);
			
			for (int j=0; j<vec_size; j++)
			{
				fprintf(fid2," %f",cvGetReal2D(euler_angles,i,j));
			}
			fprintf(fid2,"\n");
			hmm_types.Next();
		}
		fclose(fid2);
	}

	fclose(fid);


	return 0;
}